package com.unipi.talepis;

//import com.google.gson.GsonBuilder;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class Main {
    public static List<Block> blockChain = new ArrayList<>();
    public static int prefix = 5;
    public static void main(String[] args) {
        long startTime = System.nanoTime();
        System.out.println("Process started");

        //Genesis Block
        Block genesisBlock = new Block("0","Very important data",new Date().getTime());
        genesisBlock.mineBlock(prefix);
        blockChain.add(genesisBlock);
        System.out.println("Node:"+(blockChain.size()-1)+" created");

        //Second block
        Block secondBlock = new Block(blockChain.get(blockChain.size()-1).getHash(),"Some other data",new Date().getTime());
        secondBlock.mineBlock(prefix);
        blockChain.add(secondBlock);
        System.out.println("Node:"+(blockChain.size()-1)+" created");

        //Third block
        Block thirdBlock = new Block(blockChain.get(blockChain.size()-1).getHash(),"Some more data",new Date().getTime());
        thirdBlock.mineBlock(prefix);
        blockChain.add(thirdBlock);
        System.out.println("Node:"+(blockChain.size()-1)+" created");

        long endTime = System.nanoTime();
        long duration = endTime-startTime;
        System.out.println("Total time for 3 blocks:"+(float)duration/1000000000+ " seconds");
        System.out.println(blockChain);
        System.out.println("BlockChain is valid?:"+ChainValidator.isChainValid(prefix,blockChain));

        /*String blockChainJson = new GsonBuilder().setPrettyPrinting().create().toJson(blockChain);
        System.out.println("Your blockchain is:");
        System.out.println(blockChainJson);*/
    }
}
